> For the complete documentation index, see [llms.txt](https://docs.skrape.it/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.skrape.it/docs/examples/most-simple-spring-boot-example.md).

# Creating a RESTful API (Spring-Boot)

This is a basic example on how you could build a REST API directly return data from a scraped website as JSON:

```kotlin
import it.skrape.extract
import it.skrape.selects.elements
import it.skrape.selects.element
import it.skrape.skrape
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RestController

@RestController
class MyController {

    @GetMapping("/user-data")
    fun extractGithubUserData() =
        skrape {
            url = "https://github.com/skrapeit"
            extract {
                MyScrapedData(
                    userName = element(".h-card .p-nickname").text(),
                    repositoryNames = elements("span.repo").map { it.text() }
                )
            }
        }
}

data class MyScrapedData(val userName: String, val repositoryNames: List<String>)
```

This will return the following JSON as response body when `/user-data` is getting called:&#x20;

```javascript
{
  "userName": "skrapeit",
  "repositoryNames": [
    "skrape.it",
    "skrapeit-docs",
    "skrapeit-ktor-extension",
    "skrapeit-mockmvc-extension",
    "skrapeit-parent"
  ]
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.skrape.it/docs/examples/most-simple-spring-boot-example.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
